// Copyright (C) 2006 JackTheDipper <gybrush@punk-ass-bitch.org>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "checkbutton.h"


CheckButton::CheckButton(BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade)
: Gtk::CheckButton(cobject)
{
  this->m_refGlade = refGlade;
}

CheckButton::CheckButton()
{

}

CheckButton::~CheckButton()
{
  
}

void CheckButton::init(int id, TreeHandler* config, char* name) // for association with another widget
{
  this->isParamWidget = false;
  this->isEngineWidget = false;
  this->id = id;
//  strcpy(this->name, name); // <- i'm just too fucked up for being a c crack :-\ cannot get this to work with char*, sry freaks ;D
  std::string test = std::string(name); // <- so i'm using this c++ hack in order to copy the string
  this->name = test;
  this->setConfig(config);
  ModWidget::register_widget(this);
  this->reload();
}

void CheckButton::init(int id, TreeHandler* config) // as a standalone widget
{
  this->isParamWidget = false;
  this->isEngineWidget = false;
  this->id = id;
  this->setConfig(config);
  ModWidget::register_widget(this);
  this->reload();
}

void CheckButton::init(string category, TreeHandler* config) // as engine widget
{
  this->isParamWidget = false;
  this->isEngineWidget = true;
  this->category = category;
  this->setConfig(config);
  ModWidget::register_widget(this);
  this->reload();
}

void CheckButton::init(string category, string id, TreeHandler* config, bool alone) // as param widget
{
  this->isEngineWidget = false;
  this->isParamWidget = true;
  this->isParamAloneWidget = alone;
  this->category = category;
  this->id_string = id;
  this->setConfig(config);
  this->reload();
}


void CheckButton::reload()
{
  if(isEngineWidget)
    this->set_active(m_refConfig->getEngineOverride(this->category));
  else if(isParamWidget)
  {
    if(isParamAloneWidget)
    {
      char* value = NULL;
      char* checked = NULL;

      if((value = m_refConfig->getValue(this->category, this->id_string)) != NULL && 
            (checked = m_refConfig->getChecked(this->category, this->id_string)) != NULL  &&
            strcmp(value, "") && !strcmp(value, checked))
        this->set_active(true);
      else
        this->set_active(false);

      this->set_sensitive(m_refConfig->getOverride(this->category, this->id_string));

    }
    else
      this->set_active(m_refConfig->getOverride(this->category, this->id_string));
    
  }
  else
    this->set_active(m_refConfig->getOverride(this->id));
}

char* CheckButton::getName()
{
  if(name == "")
    return NULL;
  else
    return (char*)(this->name.c_str());
}
