// Copyright (C) 2006 JackTheDipper <gybrush@punk-ass-bitch.org>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "colorbutton.h"


ColorButton::ColorButton(BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade)
: Gtk::ColorButton(cobject)
{
  this->m_refGlade = refGlade;
}

ColorButton::ColorButton()
{

}

ColorButton::~ColorButton()
{
  
}

void ColorButton::reload()
{
  if(this->isParamWidget)
  {
    this->set_sensitive(m_refConfig->getOverride(this->category, this->id_string));

    if(char* value = m_refConfig->getValue(this->category, this->id_string))
      this->set_color(Gdk::Color(value));
  }
  else
  {
    this->set_sensitive(m_refConfig->getOverride(this->id));
    this->set_color(Gdk::Color((m_refConfig->getValue(this->id))));
  }
}
