// Copyright (C) 2006 JackTheDipper <gybrush@punk-ass-bitch.org>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <libgnome/gnome-i18n.h>
#include <gnome.h>

//#include <gtkmm/main.h>


#include "treehandler.h"
#include "configloader.h"
#include "exporter.h"
#include "mainwindow.h"

#include <iostream>
#include <fstream>

#include <sys/types.h>
#include <sys/stat.h>

#include <libintl.h>
#include <locale.h>

#include "gtkinfo.c"
#include "gtpexporter.h"
using namespace std;


#ifdef LIBXML_TREE_ENABLED

bool config_ok(string configfile, string dbfile, string gtkrcfile)
{

  if(! (ConfigLoader::check_file(gtkrcfile, true)
        || ConfigLoader::create_file(gtkrcfile)) )
  {
    cerr << "cannot create/open file " << gtkrcfile << endl;
    return false;
  }


  if(!ConfigLoader::create_include(
        gtkrcfile,
        "include \".gtkrc-2.0-gnome-color-chooser\"",
        ".gtkrc-2.0-gnome-color-chooser"))
  {
    if(!ConfigLoader::check_include(
          gtkrcfile,
          "include \".gtkrc-2.0-gnome-color-chooser\"",
          ".gtkrc-2.0-gnome-color-chooser"))
    {
      cerr << "unable to modify ~/.gtkrc-2.0" << endl;
      return false;
    }
  }


  if(!ConfigLoader::check_file(
           getenv("HOME") + string("/.gtkrc-2.0-gnome-color-chooser"), true)
     && !ConfigLoader::create_file(
              getenv("HOME") + string("/.gtkrc-2.0-gnome-color-chooser")))
  {
    cerr << "cannot create/open file "
         << getenv("HOME")
         << string("/.gtkrc-2.0-gnome-color-chooser")
         << endl;
    return false;
  }


  if(ConfigLoader::check_file(configfile)
        && !ConfigLoader::check_file(configfile, true))
  {
    cerr << "cannot write to config file " << configfile << endl;
    return false;
  }
  

  if(!ConfigLoader::check_file(dbfile))
  {    
    cerr << "cannot open gnomecc database " << dbfile << endl;
    return false;      
  }

  
  return true;
}

/*
void update_config(TreeHandler* config, string dbfile)
{
  TreeHandler* db = new TreeHandler((char*)dbfile.c_str());
  int k = 0;
  bool found = false;

  if(config->getConfigVersion() < db->getConfigVersion())
  {
    cout << "config too old, checking for updates." << endl << endl;
    
    db->gotoFirstCategory();
    for(int i=0; i < db->getCategoryCount(); i++)
    {
      k = 0;
      found = false;
      config->gotoFirstCategory();


      // compare categories and copy if necessary
      while(k < config->getCategoryCount())
      {
        if(!strcmp(config->getCategoryName(), db->getCategoryName()) )
        {
          found = true;
          break;
        }
        k++;
        config->gotoNextCategory();
      }
      if(!found)
      {
        config->addCategory(db->getCategoryNode());
        cout << "-> added category " << config->getCategoryName() << " with all children" << endl;
      }
      

      //compare elements of that category and copy if needed
      db->gotoCategoriesFirstElement();
      for(int j=0; j < db->getCategoryElementsCount(); j++)
      {      
        k = 0;
        found = false;
        config->gotoCategoriesFirstElement();

        while(k < config->getCategoryElementsCount())
        {
          if(!strcmp(config->getElementIdString(), db->getElementIdString()) )
          {
            found = true;
            break;
          }
          k++;
          config->gotoCategoriesNextElement();
        }
        if(!found)
        {
          config->addElement(db->getElementNode());
          cout << "-> added element " << config->getElementName() << " to category " << config->getCategoryName() << endl;
        }

        db->gotoCategoriesNextElement();
      }


      //compare classes of that category and copy if needed
      db->gotoCategoriesFirstClass();
      for(int j=0; j < db->getCategoryClassesCount(); j++)
      {
        k = 0;
        found = false;
        config->gotoCategoriesFirstClass();
        
        while(k < config->getCategoryClassesCount())
        {
          if(!strcmp(config->getClassName(), db->getClassName()) \
             && !strcmp(config->getClassType(), db->getClassType()) )
          {
            found = true;
            break;
          }
          k++;
          config->gotoCategoriesNextClass();
        }
        if(!found)
        {
          config->addClass(db->getClassNode());
          cout << "-> added class " << config->getClassName() << " to category " << config->getCategoryName() << endl;
        }
        
        db->gotoCategoriesNextClass();
      
      }

      db->gotoNextCategory();
    }
    
    config->setConfigVersion(db->getConfigVersion());
    cout << endl << "config now up-to-date. starting." << endl;
  }
  delete db;
}
*/




int main (int argc, char *argv[])
{

#ifdef ENABLE_NLS
  setlocale(LC_ALL,"");
  bindtextdomain(GETTEXT_PACKAGE, LOCALEDIR);
  bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
  textdomain(GETTEXT_PACKAGE);
#endif

  GnomeProgram *program;
  program = gnome_program_init
                (PACKAGE, VERSION,
                 LIBGNOMEUI_MODULE,
                 argc, argv,
//                 GNOME_PARAM_POPT_TABLE, cmd_options_table,
                 GNOME_PARAM_APP_DATADIR, DATADIR,
                 GNOME_PARAM_NONE);


  Gtk::Main kit(argc, argv);


//  bool found_old_config = false;
  string configfile = string(getenv("HOME")).append("/.gnome-color-chooser/config.xml");
  string configpath = string(getenv("HOME")).append("/.gnome-color-chooser/");
  string configpath_images = configpath + string("images/");
  //string globalpath_engines = string(DBDIR) + "/engines/";
  //string globalpath_engines = "/usr/share/gtk-engines/";
  string globalpath_engines = DATADIR + string("/gtk-engines/");
//  string configpath_old = string(getenv("HOME"));
  string dbfile = string(DBDIR).append("/gnome-color-chooser.db");
  string gtkrcfile = string(getenv("HOME")).append("/.gtkrc-2.0").c_str();


  cout << "Welcome to " << PACKAGE << " version " << VERSION
       << " for " << YOUR_OS << endl << endl
       << "[Datadir: " << DATADIR << "]" << endl
       << "[Localedir: " << LOCALEDIR << "]" << endl
       << "[Gettext Package: " << GETTEXT_PACKAGE << "]" << endl << endl;
  

  test(argc, argv);
  
  cout << endl;


/*
  ifstream config_old( (configpath_old + string("/.gnome-color-chooser")).c_str() );

  if(config_old)
  {
    struct stat config_stat;
    stat( (configpath_old + string("/.gnome-color-chooser")).c_str(), &config_stat);
//    string line;
//    getline(config_old, line);
    if(config_stat.st_mode & S_IFREG) // if a regular file (no directory, etc)
    {
//    if(line != "") // if not e.g. a directory
      cout << "moving old configuration file to " << configfile << endl;
      found_old_config = true;
      config_old.close();
      if(rename( (configpath_old + string("/.gnome-color-chooser")).c_str(), (configpath_old + string("/.gnome_color_chooser")).c_str()) == -1)
      {
        cout << configpath_old << endl;
        perror("error");
      }
    }
    else
    {
      config_old.close();
    }
  }
*/
  
  if(mkdir(configpath.c_str(), (mode_t)00700) != -1)
  {
/*    if(found_old_config)
    {
      rename((configpath_old + string("/.gnome_color_chooser")).c_str(), configfile.c_str());
    }*/
    if(mkdir(configpath_images.c_str(), (mode_t)00755) == -1)
    {
      perror(configpath_images.c_str());
      return 1;
    }
  }


  if(!config_ok(configfile, dbfile, gtkrcfile))
    return 1;


  // config has to be loaded before the glade file
  TreeHandler* pConfig = new TreeHandler((char*)dbfile.c_str());
  Exporter::init(pConfig);

  //update_config(pConfig, dbfile);


  cout << "Loading GUI with libglade.. " << flush;

  //Load the Glade file and instantiate its widgets:
  Glib::RefPtr<Gnome::Glade::Xml> refXml;
  try
  {
    //refXml = Gnome::Glade::Xml::create("gnome-color-chooser.glade");
    refXml = Gnome::Glade::Xml::create(string(GLADEDIR) + string("/gnome-color-chooser.glade"));
  }
  catch(const Gnome::Glade::XmlError& ex)
  {
    cerr << endl << ex.what() << endl;
    return 1;
  }

  cout << "done" << endl;
  cout << "Initializing and starting " << PACKAGE << ".. " << flush;

/* TESTAREA     */
/*
  Exporter* exporter = Exporter::create_exporter(Exporter::Gtp);
  try
  {
    exporter->export_to( "bla", "bla" );
  }
  catch(Exception &e)
  {
    cerr << "Export to " << "bla" << " failed: " << e.get_string() << endl;
  }

  delete exporter;
*/
/* TESTAREA END */



//  cout << endl; 

  //Get the Glade-instantiated window:
  MainWindow* pWindow = 0;
  refXml->get_widget_derived("window1", pWindow);
  if(pWindow)
  {
    pWindow->init(pConfig, configfile, VERSION, string(ICONDIR) + string("/gnome-color-chooser.svg"), configpath_images, globalpath_engines);
    cout << "done" << endl;
    //Start:
    kit.run(*pWindow);
  }

  delete pWindow;
  delete pConfig;

  return 0;
}

#else
int main(void) {
    cerr << "Tree support of libxml2 not compiled in\n";
    exit(1);
}
#endif

